Install openssh-client in all centos bootstraps
[csit.git] / bootstrap-vpp-verify-semiweekly.sh
1 #!/bin/bash
2 # Copyright (c) 2016 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a ght (c) 2016 Cisco and/or its affiliates.
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not usecopy of the License at:
8 #
9 #     http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16
17 set -x
18
19 RETURN_STATUS=0
20
21 cat /etc/hostname
22 cat /etc/hosts
23
24 PYBOT_ARGS="--noncritical MULTI_THREAD"
25
26 JOB_ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
27 LOG_ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
28 JOB_ARCHIVE_DIR="archive"
29 LOG_ARCHIVE_DIR="$WORKSPACE/archives"
30 mkdir -p ${JOB_ARCHIVE_DIR}
31 mkdir -p ${LOG_ARCHIVE_DIR}
32
33 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
34 export PYTHONPATH=${SCRIPT_DIR}
35
36 # Create tmp dir
37 mkdir ${SCRIPT_DIR}/tmp
38
39 # Use tmp dir to store log files
40 LOG_PATH="${SCRIPT_DIR}/tmp"
41
42 OS_ID=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g')
43 OS_VERSION_ID=$(grep '^VERSION_ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g')
44
45 if [ "$OS_ID" == "centos" ]; then
46     DISTRO="CENTOS"
47     PACKAGE="rpm"
48     sudo yum install -y python-devel python-virtualenv openssh-client
49 elif [ "$OS_ID" == "ubuntu" ]; then
50     DISTRO="UBUNTU"
51     PACKAGE="deb"
52     export DEBIAN_FRONTEND=noninteractive
53     sudo apt-get -y update
54     sudo apt-get -y install libpython2.7-dev python-virtualenv
55 else
56     echo "$OS_ID is not yet supported."
57     exit 1
58 fi
59
60 # 1st step: Download and prepare VPP packages
61
62 # Temporarily download VPP packages from nexus.fd.io
63 if [ "${#}" -ne "0" ]; then
64     arr=(${@})
65     echo ${arr[0]}
66 else
67     # Download the latest VPP build install packages
68     CSIT_DIR=${SCRIPT_DIR}
69     source "${SCRIPT_DIR}/resources/libraries/bash/function/artifacts.sh"
70     download_artifacts
71     # Need to revert -euo as the rest of script is not optimized for this.
72     set +euo pipefail
73 fi
74
75 VIRL_DIR_LOC="/tmp/"
76 VPP_PKGS=(*vpp*.$PACKAGE)
77 VPP_PKGS_FULL=("${VPP_PKGS[@]/#/${VIRL_DIR_LOC}}")
78 echo ${VPP_PKGS[@]}
79
80 VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_${DISTRO})
81 VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_${DISTRO})
82
83 VPP_VER="$( expr match $(ls vpp*.${PACKAGE} | head -n 1) 'vpp[-|_]\(.*\)'.${PACKAGE} )"
84
85 set +x
86 echo "****************************************************************************************************************************************"
87 echo "1st step: Download VPP packages                                                                                                 FINISHED"
88 echo "VPP version to be tested: ${VPP_VER}"
89 echo "****************************************************************************************************************************************"
90 set -x
91
92
93 # 2nd step: Start virtual env and install requirements
94
95 echo Starting virtual env...
96 virtualenv --system-site-packages env
97 . env/bin/activate
98
99 echo Installing requirements...
100 pip install -r ${SCRIPT_DIR}/requirements.txt
101
102 set +x
103 echo "****************************************************************************************************************************************"
104 echo "2nd step: Start virtual env and install requirements                                                                            FINISHED"
105 echo "****************************************************************************************************************************************"
106 set -x
107
108
109 # 3rd step: Prepare VIRL system
110 echo Preparing VIRL system...
111
112 VIRL_SERVERS=("10.30.51.28" "10.30.51.29" "10.30.51.30")
113 VIRL_SERVER=""
114
115 VIRL_USERNAME=jenkins-in
116 VIRL_PKEY=priv_key
117 VIRL_SERVER_STATUS_FILE="status"
118 VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
119 VIRL_SESSION_EXPIRY="620"
120
121 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
122
123 function ssh_do() {
124     echo
125     echo "### "  ssh $@
126     ssh ${SSH_OPTIONS} $@
127 }
128
129 rm -f ${VIRL_PKEY}
130 cat > ${VIRL_PKEY} <<EOF
131 -----BEGIN RSA PRIVATE KEY-----
132 MIIEpQIBAAKCAQEA+IHXq87GcqMR1C47rzx6Cbip5Ghq8pKrbqKrP5Nf41HcYrT6
133 GOXl9nFWKsMOzIlIn+8y7Il27eZh7csQGApbg8QLiHMtcYEmWNzKZpkqg4nuAPxX
134 VXwlKgnKX902SrET9Gp9TDayiHtCRWVfrlPPPSA0UEXW6BjLN/uHJ+W/Xzrrab+9
135 asBVa05vT2W6n0KJ66zfCaeDM912mQ6SttscAwFoWDmdHlegiVqrlIG2ABxOvxxz
136 L3dM3iSmlmQlzv9bThjo+nI4KFYh6m5wrZmAo5r/4q9CIJc21HVnTqkGOWJIZz6J
137 73lePJVSq5gYqaoGw3swFEA/MDkOx7baWKSoLQIDAQABAoIBAQCNBeolNp+JWJ76
138 gQ4fwLsknyXSV6sxYyhkDW4PEwwcTU06uqce0AAzXVffxne0fMe48x47+zqBgPbb
139 4huM+Pu8B9nfojUMr5TaYtl9Zbgpk3F8H7dT7LKOa6XrxvZTZrADSRc30+Z26zPN
140 e9zTaf42Gvt0/l0Zs1BHwbaOXqO+XuwJ3/F9Sf3PQYWXD3EOWjpHDP/X/1vAs6lV
141 SLkm6J/9KKE1m6I6LTYjIXuYt4SXybW6N2TSy54hhQtYcDUnIU2hR/PHVWKrGA0J
142 kELgrtTNTdbML27O5gFWU4PLUEYTZ9fN11D6qUZKxLcPOiPPHXkiILMRCCnG5DYI
143 ksBAU/YlAoGBAPxZO9VO18TYc8THV1nLKcvT2+1oSs1UcA2wNQMU55t910ZYinRa
144 MRwUhMOf8Mv5wOeiZaRICQB1PnVWtDVmGECgPpK6jUxqAwn8rgJcnoafLGL5YKMY
145 RVafTe6N5LXgCaOcJrk21wxs6v7ninEbUxxc575urOvZMBkymDw91dwbAoGBAPwa
146 YRhKhrzFKZzdK0RadVjnxKvolUllpoqqg3XuvmeAJHAOAnaOgVWq68NAcp5FZJv0
147 2D2Up7TX8pjf9MofP1SJbcraKBpK4NzfNkA0dSdEi+FhVofAJ9umB2o5LW1n7sab
148 UIrjsdzSJK/9Zb9yTTHPyibYzNEgaJV1HsbxfEFXAoGAYO2RmvRm0phll18OQVJV
149 IpKk9kLKAKZ/R/K32hAsikBC8SVPQTPniyaifFWx81diblalff2hX4ipTf7Yx24I
150 wMIMZuW7Im/R7QMef4+94G3Bad7p7JuE/qnAEHJ2OBnu+eYfxaK35XDsrq6XMazS
151 NqHE7hOq3giVfgg+C12hCKMCgYEAtu9dbYcG5owbehxzfRI2/OCRsjz/t1bv1seM
152 xVMND4XI6xb/apBWAZgZpIFrqrWoIBM3ptfsKipZe91ngBPUnL9s0Dolx452RVAj
153 yctHB8uRxWYgqDkjsxtzXf1HnZBBkBS8CUzYj+hdfuddoeKLaY3invXLCiV+PpXS
154 U4KAK9kCgYEAtSv0m5+Fg74BbAiFB6kCh11FYkW94YI6B/E2D/uVTD5dJhyEUFgZ
155 cWsudXjMki8734WSpMBqBp/J8wG3C9ZS6IpQD+U7UXA+roB7Qr+j4TqtWfM+87Rh
156 maOpG56uAyR0w5Z9BhwzA3VakibVk9KwDgZ29WtKFzuATLFnOtCS46E=
157 -----END RSA PRIVATE KEY-----
158 EOF
159 chmod 600 ${VIRL_PKEY}
160
161 #
162 # Pick a random host from the array of VIRL servers, and attempt
163 # to reach it and verify it's status.
164 #
165 # The server must be reachable, and have a "status" file with
166 # the content "PRODUCTION", to be selected.
167 #
168 # If the server is not reachable, or does not have the correct
169 # status, remove it from the array and start again.
170 #
171 # Abort if there are no more servers left in the array.
172 #
173 while [[ ! "$VIRL_SERVER" ]]
174 do
175     num_hosts=${#VIRL_SERVERS[@]}
176     if [ $num_hosts == 0 ]
177     then
178         echo "No more VIRL candidate hosts available, failing."
179         exit 127
180     fi
181     element=$[ $RANDOM % $num_hosts ]
182     virl_server_candidate=${VIRL_SERVERS[$element]}
183     virl_server_status=$(ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${virl_server_candidate} cat $VIRL_SERVER_STATUS_FILE 2>&1)
184     echo VIRL HOST $virl_server_candidate status is \"$virl_server_status\"
185     if [ "$virl_server_status" == "$VIRL_SERVER_EXPECTED_STATUS" ]
186     then
187         # Candidate is in good status. Select this server.
188         VIRL_SERVER="$virl_server_candidate"
189     else
190         # Candidate is in bad status. Remove from array.
191         VIRL_SERVERS=("${VIRL_SERVERS[@]:0:$element}" "${VIRL_SERVERS[@]:$[$element+1]}")
192     fi
193 done
194
195 # Copy the files to VIRL host
196 scp ${SSH_OPTIONS} ${VPP_PKGS[@]} \
197     ${VIRL_USERNAME}@${VIRL_SERVER}:${VIRL_DIR_LOC}/
198
199 result=$?
200 if [ "${result}" -ne "0" ]; then
201     echo "Failed to copy vpp deb files to virl host"
202     echo ${result}
203     exit ${result}
204 fi
205
206 # Start a simulation on VIRL server
207 echo "Starting simulation on VIRL server"
208
209 function stop_virl_simulation {
210     ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVER}\
211         "stop-testcase ${VIRL_SID}"
212 }
213
214 VIRL_SID=$(ssh ${SSH_OPTIONS} \
215     ${VIRL_USERNAME}@${VIRL_SERVER} \
216     "start-testcase -vv --copy ${VIRL_TOPOLOGY} \
217     --expiry ${VIRL_SESSION_EXPIRY} \
218     --release ${VIRL_RELEASE} ${VPP_PKGS_FULL[@]}")
219 retval=$?
220 if [ ${retval} -ne "0" ]; then
221     echo "VIRL simulation start failed"
222     exit ${retval}
223 fi
224
225 if [[ ! "${VIRL_SID}" =~ session-[a-zA-Z0-9_]{6} ]]; then
226     echo "No VIRL session ID reported."
227     exit 127
228 fi
229
230 # Upon script exit, cleanup the VIRL simulation execution
231 trap stop_virl_simulation EXIT
232 echo ${VIRL_SID}
233
234 ssh_do ${VIRL_USERNAME}@${VIRL_SERVER} cat /scratch/${VIRL_SID}/topology.yaml
235
236 # Download the topology file from VIRL session
237 scp ${SSH_OPTIONS} \
238     ${VIRL_USERNAME}@${VIRL_SERVER}:/scratch/${VIRL_SID}/topology.yaml \
239     topologies/enabled/topology_VIRL.yaml
240
241 retval=$?
242 if [ ${retval} -ne "0" ]; then
243     echo "Failed to copy topology file from VIRL simulation"
244     exit ${retval}
245 fi
246
247 set +x
248 echo "****************************************************************************************************************************************"
249 echo "3rd step: Start the simulation on the VIRL server                                                                               FINISHED"
250 echo "****************************************************************************************************************************************"
251 set -x
252
253
254 # 4th step: Run functional test suites
255
256 RC=0
257 MORE_FAILS=0
258
259 echo Running functional tests on the VIRL system...
260
261 # There are used three iterations of functional tests there
262 # to check the stability and reliability of the results.
263 partial_logs=""
264 for test_set in 1 2
265 do
266     echo
267     echo Functional test loop: ${test_set}
268     echo
269
270     pybot -L TRACE -W 136\
271         -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology_VIRL.yaml \
272         --suite "tests.vpp.func" \
273         --include vm_envAND3_node_single_link_topo \
274         --include vm_envAND3_node_double_link_topo \
275         --exclude PERFTEST \
276         --exclude SOFTWIRE \
277         --exclude SKIP_TEST \
278         --noncritical EXPECTED_FAILING \
279         --output ${LOG_PATH}/output_func_test_set${test_set} \
280         tests/
281     PARTIAL_RC=$(echo $?)
282     partial_logs="${partial_logs} ${LOG_PATH}/output_func_test_set${test_set}.xml"
283     if [ ${PARTIAL_RC} -eq 250 ]; then
284         MORE_FAILS=1
285     fi
286     RC=$((RC+PARTIAL_RC))
287 done
288
289 set +x
290 echo "****************************************************************************************************************************************"
291 echo "4th step: Run functional tests                                                                                                  FINISHED"
292 echo "****************************************************************************************************************************************"
293 set -x
294
295 # Set RETURN_STATUS=1 if some critical test failed
296 if [ ! ${RC} -eq 0 ]; then
297         RETURN_STATUS=1
298 fi
299
300 # Log the final result
301 if [ ${RC} -eq 0 ]; then
302     set +x
303     echo
304     echo "========================================================================================================================================"
305     echo "Final result of all test loops:                                                                                                 | PASS |"
306     echo "All critical tests have passed."
307     echo "========================================================================================================================================"
308     echo
309     set -x
310 elif [ ${MORE_FAILS} -eq 0 ]; then
311     if [ ${RC} -eq 1 ]; then
312         HLP_STR="test has"
313     else
314         HLP_STR="tests have"
315     fi
316     set +x
317     echo
318     echo "========================================================================================================================================"
319     echo "Final result of all test loops:                                                                                                 | FAIL |"
320     echo "${RC} critical ${HLP_STR} failed."
321     echo "========================================================================================================================================"
322     echo
323     set -x
324 else
325     set +x
326     echo
327     echo "========================================================================================================================================"
328     echo "Final result of all test loops:                                                                                                 | FAIL |"
329     echo "More then 250 critical tests have failed in one test loop."
330     echo "========================================================================================================================================"
331     echo
332     set -x
333 fi
334
335 # 7th step: Post-processing test data
336 echo Post-processing test data...
337
338 # Rebot output post-processing
339 rebot --noncritical EXPECTED_FAILING \
340       --output output.xml ${partial_logs}
341
342 # Remove unnecessary files
343 rm -f ${partial_logs}
344
345 # Archive JOB artifacts in jenkins
346 for i in ${JOB_ARCHIVE_ARTIFACTS[@]}; do
347     cp $( readlink -f ${i} | tr '\n' ' ' ) ${JOB_ARCHIVE_DIR}/
348 done
349 # Archive JOB artifacts to logs.fd.io
350 for i in ${LOG_ARCHIVE_ARTIFACTS[@]}; do
351     cp $( readlink -f ${i} | tr '\n' ' ' ) ${LOG_ARCHIVE_DIR}/
352 done
353
354 echo Post-processing finished.
355
356 exit ${RETURN_STATUS}

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.